package com.tmax.openframe.variable;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.variable.group.*;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPQUIT_VariableContainer {
    public @Getter String WS_TRANS_ID = "OIQU";
    public @Getter String WS_MAPSET_NAME = "OIVPM07";
    public @Getter String WS_MAP_NAME = "OIVPM07";
    public @Getter @Setter int WS_RESPONSE_CODE;
    public @Getter @Setter int WS_RESPONSE_CODE2;
    public @Getter String WS_COMMUNICATION_AREA = StringUtils.repeat(' ', 1);
    public @Getter String WS_END_MESSAGE = "THANK YOU FOR USING OPENFRAME ONLINE";
    public @Getter @Setter int WS_FIRST_TIME_FLAG;
    public @Getter @Setter OIVPQUIT_WS_ERROR_MESSAGE WS_ERROR_MESSAGE = new OIVPQUIT_WS_ERROR_MESSAGE();
    public @Getter @Setter OIVPQUIT_OIVPM07I OIVPM07I = new OIVPQUIT_OIVPM07I();

    public OIVPQUIT_OIVPM07O getOIVPM07O() {
        return OIVPQUIT_OIVPM07O.builder().FILLER7(getFILLER7())
                .FILLER8(getFILLER8()).DATEO(getDATEO()).FILLER9(getFILLER9())
                .TERMO(getTERMO()).FILLER10(getFILLER10()).TIMEO(getTIMEO())
                .FILLER11(getFILLER11()).ENDMO(getENDMO())
                .FILLER12(getFILLER12()).MSGO(getMSGO()).build();
    }

    public void setOIVPM07O(String source) {
        setFILLER7(source.substring(0, 12));
        setFILLER8(source.substring(12, 15));
        setDATEO(source.substring(15, 23));
        setFILLER9(source.substring(23, 26));
        setTERMO(source.substring(26, 30));
        setFILLER10(source.substring(30, 33));
        setTIMEO(source.substring(33, 41));
        setFILLER11(source.substring(41, 44));
        setENDMO(source.substring(44, 80));
        setFILLER12(source.substring(80, 83));
        setMSGO(source.substring(83, 159));
    }

    public void setOIVPM07O(OIVPQUIT_OIVPM07O source) {
        setOIVPM07O(source.toString());
    }

    public String getFILLER7() {
        return getOIVPM07I().getFILLER1();
    }

    public void setFILLER7(String source) {
        OIVPM07I.setFILLER1(source);
    }

    public String getFILLER8() {
        return String.valueOf(getOIVPM07I().getDATEL())
                + getOIVPM07I().getDATEF();
    }

    public void setFILLER8(String source) {
        OIVPM07I.setDATEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM07I.setDATEF(source.substring(2));
    }

    public String getDATEO() {
        return getOIVPM07I().getDATEI();
    }

    public void setDATEO(String source) {
        OIVPM07I.setDATEI(source);
    }

    public String getFILLER9() {
        return String.valueOf(getOIVPM07I().getTERML())
                + getOIVPM07I().getTERMF();
    }

    public void setFILLER9(String source) {
        OIVPM07I.setTERML(Integer.parseInt(source.substring(0, 2)));
        OIVPM07I.setTERMF(source.substring(2));
    }

    public String getTERMO() {
        return getOIVPM07I().getTERMI();
    }

    public void setTERMO(String source) {
        OIVPM07I.setTERMI(source);
    }

    public String getFILLER10() {
        return String.valueOf(getOIVPM07I().getTIMEL())
                + getOIVPM07I().getTIMEF();
    }

    public void setFILLER10(String source) {
        OIVPM07I.setTIMEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM07I.setTIMEF(source.substring(2));
    }

    public String getTIMEO() {
        return getOIVPM07I().getTIMEI();
    }

    public void setTIMEO(String source) {
        OIVPM07I.setTIMEI(source);
    }

    public String getFILLER11() {
        return String.valueOf(getOIVPM07I().getENDML())
                + getOIVPM07I().getENDMF();
    }

    public void setFILLER11(String source) {
        OIVPM07I.setENDML(Integer.parseInt(source.substring(0, 2)));
        OIVPM07I.setENDMF(source.substring(2));
    }

    public String getENDMO() {
        return getOIVPM07I().getENDMI();
    }

    public void setENDMO(String source) {
        OIVPM07I.setENDMI(source);
    }

    public String getFILLER12() {
        return String.valueOf(getOIVPM07I().getMSGL())
                + getOIVPM07I().getMSGF();
    }

    public void setFILLER12(String source) {
        OIVPM07I.setMSGL(Integer.parseInt(source.substring(0, 2)));
        OIVPM07I.setMSGF(source.substring(2));
    }

    public String getMSGO() {
        return getOIVPM07I().getMSGI();
    }

    public void setMSGO(String source) {
        OIVPM07I.setMSGI(source);
    }

    public @Getter String DEFINITIONS_OF_EIBAID_FIELD = StringUtils.repeat(' ',
            1);
    public @Getter @Setter OIVPQUIT_WS_DATE_TIME_AREA WS_DATE_TIME_AREA = new OIVPQUIT_WS_DATE_TIME_AREA();
    public @Getter String START_CODE = StringUtils.repeat(' ', 2);
    public @Getter String DFHCOMMAREA = StringUtils.repeat(' ', 1);
    private final static BiFunction<Long, String, String> intFormatWithSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.applyPattern("+" + format + ";-" + format);
        return nf.format(value);
    };

    public void setWS_TRANS_ID(String source) {
        WS_TRANS_ID = StringUtils.truncate(StringUtils.rightPad(source, 4), 4);
    }

    public void setWS_MAPSET_NAME(String source) {
        WS_MAPSET_NAME = StringUtils.truncate(StringUtils.rightPad(source, 7),
                7);
    }

    public void setWS_MAP_NAME(String source) {
        WS_MAP_NAME = StringUtils.truncate(StringUtils.rightPad(source, 7), 7);
    }

    public String getStringWS_RESPONSE_CODE() {
        return intFormatWithSign.apply((long) WS_RESPONSE_CODE, "00000000");
    }

    public String getStringWS_RESPONSE_CODE2() {
        return intFormatWithSign.apply((long) WS_RESPONSE_CODE2, "00000000");
    }

    public void setWS_COMMUNICATION_AREA(String source) {
        WS_COMMUNICATION_AREA = StringUtils.truncate(
                StringUtils.rightPad(source, 1), 1);
    }

    public void setWS_END_MESSAGE(String source) {
        WS_END_MESSAGE = StringUtils.truncate(StringUtils.rightPad(source, 36),
                36);
    }

    public String getStringWS_FIRST_TIME_FLAG() {
        return intFormatWithSign.apply((long) WS_FIRST_TIME_FLAG, "0000");
    }

    public void setDEFINITIONS_OF_EIBAID_FIELD(String source) {
        DEFINITIONS_OF_EIBAID_FIELD = StringUtils.truncate(
                StringUtils.rightPad(source, 1), 1);
    }

    public void setSTART_CODE(String source) {
        START_CODE = StringUtils.truncate(StringUtils.rightPad(source, 2), 2);
    }

    public void setDFHCOMMAREA(String source) {
        DFHCOMMAREA = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }
}
